// () ..,2003
// http://alwd.narod.ru
// mailto:alwd@narod.ru

{$B-}
unit BoxesEx;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TBoxExForm = class(TForm)
    YesBtn: TButton;
    NoBtn: TButton;
    HelpBtn: TButton;
    CancelBtn: TButton;
    StaticText: TStaticText;
    Bevel1: TBevel;
    procedure HelpBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure FormHide(Sender: TObject);
  private
    fHelpContext : integer;
    by,bn,bc,bh: integer;
    procedure CenterButtons;
  public
  end;

var
  BoxExForm: TBoxExForm;

// HelpContext -  HelpContext  Application
//
// Condition ,    .
//   Condition = FALSE,  Box'   ,
//     AskBox, YesNoBox  
//   TRUE,     [].
//    YesNoCancelBox
//      ,  mrYes
//   Cond*Box  :
//  if Condition = FALSE then ModalResult := mrYes;
//
//   AskBox, YesNoBox
//   TRUE     []
//   FALSE      
//
//   YesNoCancelBox
//   ,  ModalResult
//
// MessageBox, CondMessageBox:
//       --------------------------
//       | !              |
//       |                        |
//       |      Message text      |     ModalResult[] = mrYes
//       |                        |
//       |          []          |
//       |                        |
//       --------------------------
//
// MessageHelpBox, CondMessageHelpBox:
//       --------------------------
//       | !              |
//       |                        |
//       |      Message text      |     ModalResult[] = mrYes
//       |                        |     ModalResult[] = mrNone
//       |     []  []    |
//       |                        |
//       --------------------------
procedure MessageBox(MessageText: string);
procedure MessageHelpBox(MessageText: string; HelpContext: integer);
procedure CondMessageBox(MessageText: string; Condition: boolean);
procedure CondMessageHelpBox(MessageText: string; HelpContext: integer; Condition: boolean);

// ErrorBox, CondErrorBox:
//       --------------------------
//       | !                |
//       |                        |
//       |      Message text      |     ModalResult[] = mrYes
//       |                        |
//       |          []          |
//       |                        |
//       --------------------------
//
// ErrorHelpBox, CondErrorHelpBox:
//       --------------------------
//       | !                |
//       |                        |
//       |      Message text      |     ModalResult[] = mrYes
//       |                        |     ModalResult[] = mrNone
//       |     []  []    |
//       |                        |
//       --------------------------
procedure ErrorBox(ErrorMessageText: string);
procedure ErrorHelpBox(ErrorMessageText: string; HelpContext: integer);
procedure CondErrorBox(ErrorMessageText: string; Condition: boolean);
procedure CondErrorHelpBox(ErrorMessageText: string; HelpContext: integer; Condition: boolean);

// AskBox, CondAskBox, YesNoBox, CondYesNoBox:
//       --------------------------
//       | :              |
//       |                        |
//       |      Message text      |     ModalResult[] = mrYes
//       |                        |     ModalResult[] = mrNo
//       |       []  []      |
//       |                        |
//       --------------------------
//
// AskHelpBox, CondAskHelpBox, YesNoHelpBox, CondYesNoHelpBox:
//       --------------------------
//       | :              |
//       |                        |
//       |      Message text      |     ModalResult[] = mrYes
//       |                        |     ModalResult[] = mrNo
//       |  [] [] []  |     ModalResult[] = mrNone
//       |                        |
//       --------------------------
//
//    
function YesNoBox(Text: string): boolean;
function YesNoHelpBox(Text: string; HelpContext: integer): boolean;
function CondYesNoBox(Condition: boolean; Text: string): boolean;
function CondYesNoHelpBox(Condition: boolean; Text: string; HelpContext: integer): boolean;
//     Boxes
function AskBox(AskText: string): boolean;
function AskHelpBox(AskText: string; HelpContext: integer): boolean;
function CondAskBox(AskText: string; Condition: boolean): boolean;
function CondAskHelpBox(AskText: string; HelpContext: integer; Condition: boolean): boolean;

// YesNoCancelBox, CondYesNoCancelBox:
//       --------------------------
//       | :              |
//       |                        |
//       |      Message text      |     ModalResult[] = mrYes
//       |                        |     ModalResult[] = mrNo
//       |  [] [] []   |     ModalResult[] = mrCancel
//       |                        |
//       --------------------------
//
// YesNoCancelHelpBox, CondYesNoCancelHelpBox:
//  ----------------------------------
//  | :                      |
//  |                                |     ModalResult[] = mrYes
//  |          Message text          |     ModalResult[] = mrNo
//  |                                |     ModalResult[] = mrCancel
//  | [] [] [] []  |     ModalResult[] = mrNone
//  |                                |
//  ----------------------------------
function YesNoCancelBox(Text: string): integer;
function YesNoCancelHelpBox(Text: string; HelpContext: integer): integer;
function CondYesNoCancelBox(Condition: boolean; Text: string): integer;
function CondYesNoCancelHelpBox(Condition: boolean; Text: string; HelpContext: integer): integer;

implementation

const
  gERRORBOX_CAPTION          = '!';
  gMESSAGEBOX_CAPTION        = '!';
  gASKBOX_CAPTION            = ':';
  vk_Esc                     = 27;

  gErrorColor                = clWhite;
  gErrorFontColor            = clRed;
  gColor                     = clBtnFace;
  gFontColor                 = clWindowText;

{$R *.DFM}

procedure TBoxExForm.CenterButtons;
var
  i,Center : integer;
begin
   i := 0;
   if YesBtn.Visible then Inc(i);
   if NoBtn.Visible then Inc(i,10);
   if CancelBtn.Visible then Inc(i,100);
   if HelpBtn.Visible then Inc(i,1000);
   Center := ClientWidth shr 1;
   case i of
     //   
     1: YesBtn.Left := Center - YesBtn.Width shr 1;
     //   
     1001:
       begin // [] []
         YesBtn.Left := Center - YesBtn.Width - 5;
         HelpBtn.Left := Center + 5;
       end;
     11:
       begin // [] []
         YesBtn.Left := Center - YesBtn.Width - 5;
         NoBtn.Left := Center + 5;
       end;
     //   
     111:
       begin // [] [] []
         with YesBtn do Left := Center - Width - Width shr 1 - 10;
         with NoBtn do Left := Center - Width shr 1;
         with CancelBtn do Left := Center + Width shr 1 + 10;
       end;
     1011:
       begin // [] [] []
         with YesBtn do Left := Center - Width - Width shr 1 - 10;
         with NoBtn do Left := Center - Width shr 1;
         with HelpBtn do Left := Center + Width shr 1 + 10;
       end;
     //   
     1111:
       begin
         YesBtn.Left := by;
         NoBtn.Left := bn;
         CancelBtn.Left := bc;
         HelpBtn.Left := bh;
       end;
   end; // case
   YesBtn.SetFocus;
end;



procedure MessageBox;
begin
  BoxExForm.Caption := gMESSAGEBOX_CAPTION;
  BoxExForm.StaticText.Caption := MessageText;
  BoxExForm.StaticText.Color := gColor;
  BoxExForm.StaticText.Font.Color := gFontColor;
  BoxExForm.NoBtn.Visible := FALSE;
  BoxExForm.CancelBtn.Visible := FALSE;
  BoxExForm.HelpBtn.Visible := FALSE;
  BoxExForm.ShowModal;
end;

procedure MessageHelpBox;
begin
  BoxExForm.Caption := gMESSAGEBOX_CAPTION;
  BoxExForm.StaticText.Caption := MessageText;
  BoxExForm.StaticText.Color := gColor;
  BoxExForm.StaticText.Font.Color := gFontColor;
  BoxExForm.NoBtn.Visible := FALSE;
  BoxExForm.CancelBtn.Visible := FALSE;
  BoxExForm.HelpBtn.Visible := TRUE;
  BoxExForm.fHelpContext := HelpContext;
  BoxExForm.ShowModal;
end;

procedure CondMessageBox;
begin
  if Condition then MessageBox(MessageText);
end;

procedure CondMessageHelpBox;
begin
  if Condition then MessageHelpBox(MessageText,HelpContext);
end;



procedure ErrorBox;
begin
  BoxExForm.Caption := gERRORBOX_CAPTION;
  BoxExForm.StaticText.Caption := ErrorMessageText;
  BoxExForm.StaticText.Color := gErrorColor;
  BoxExForm.StaticText.Font.Color := gErrorFontColor;
  BoxExForm.NoBtn.Visible := FALSE;
  BoxExForm.CancelBtn.Visible := FALSE;
  BoxExForm.HelpBtn.Visible := FALSE;
  BoxExForm.ShowModal;
end;

procedure ErrorHelpBox;
begin
  BoxExForm.Caption := gERRORBOX_CAPTION;
  BoxExForm.StaticText.Caption := ErrorMessageText;
  BoxExForm.StaticText.Color := gErrorColor;
  BoxExForm.StaticText.Font.Color := gErrorFontColor;
  BoxExForm.NoBtn.Visible := FALSE;
  BoxExForm.CancelBtn.Visible := FALSE;
  BoxExForm.HelpBtn.Visible := TRUE;
  BoxExForm.fHelpContext := HelpContext;
  BoxExForm.ShowModal;
end;

procedure CondErrorBox;
begin
  if Condition then ErrorBox(ErrorMessageText);
end;

procedure CondErrorHelpBox;
begin
  if Condition then ErrorHelpBox(ErrorMessageText,HelpContext);
end;



function YesNoBox;
begin
  BoxExForm.Caption := gASKBOX_CAPTION;
  BoxExForm.StaticText.Caption := Text;
  BoxExForm.StaticText.Color := gColor;
  BoxExForm.StaticText.Font.Color := gFontColor;
  BoxExForm.NoBtn.Visible := TRUE;
  BoxExForm.CancelBtn.Visible := FALSE;
  BoxExForm.HelpBtn.Visible := FALSE;
  BoxExForm.ShowModal;
  Result := (BoxExForm.ModalResult = mrYes);
end;
function AskBox; begin Result := YesNoBox(AskText) end;

function YesNoHelpBox;
begin
  BoxExForm.Caption := gASKBOX_CAPTION;
  BoxExForm.StaticText.Caption := Text;
  BoxExForm.StaticText.Color := gColor;
  BoxExForm.StaticText.Font.Color := gFontColor;
  BoxExForm.CancelBtn.Visible := FALSE;
  BoxExForm.NoBtn.Visible := TRUE;
  BoxExForm.HelpBtn.Visible := TRUE;
  BoxExForm.fHelpContext := HelpContext;
  BoxExForm.ShowModal;
  Result := (BoxExForm.ModalResult = mrYes);
end;
function AskHelpBox; begin Result := YesNoHelpBox(AskText,HelpContext) end;

function CondYesNoBox;
begin
  Result := TRUE;
  if Condition then Result := YesNoBox(Text);
end;
function CondAskBox; begin Result := CondYesNoBox(Condition,AskText) end;

function CondYesNoHelpBox;
begin
  Result := TRUE;
  if Condition then Result := YesNoHelpBox(Text,HelpContext);
end;
function CondAskHelpBox; begin Result := CondYesNoHelpBox(Condition,AskText,HelpContext) end;



function YesNoCancelBox;
begin
  BoxExForm.Caption := gASKBOX_CAPTION;
  BoxExForm.StaticText.Caption := Text;
  BoxExForm.StaticText.Color := gColor;
  BoxExForm.StaticText.Font.Color := gFontColor;
  BoxExForm.CancelBtn.Visible := TRUE;
  BoxExForm.NoBtn.Visible := TRUE;
  BoxExForm.HelpBtn.Visible := FALSE;
  BoxExForm.ShowModal;
  Result := BoxExForm.ModalResult;
end;

function YesNoCancelHelpBox;
begin
  BoxExForm.Caption := gASKBOX_CAPTION;
  BoxExForm.StaticText.Caption := Text;
  BoxExForm.StaticText.Color := gColor;
  BoxExForm.StaticText.Font.Color := gFontColor;
  BoxExForm.fHelpContext := HelpContext;
  BoxExForm.CancelBtn.Visible := TRUE;
  BoxExForm.NoBtn.Visible := TRUE;
  BoxExForm.HelpBtn.Visible := TRUE;
  BoxExForm.ShowModal;
  Result := BoxExForm.ModalResult;
end;

function CondYesNoCancelBox;
begin
  Result := mrOk;
  if Condition then Result := YesNoCancelBox(Text);
end;

function CondYesNoCancelHelpBox;
begin
  Result := mrOk;
  if Condition then Result := YesNoCancelHelpBox(Text,HelpContext);
end;



procedure TBoxExForm.HelpBtnClick(Sender: TObject);
begin
  Application.HelpCommand(1,fHelpContext);
end;

procedure TBoxExForm.FormActivate(Sender: TObject);
begin
  CenterButtons;
end;

procedure TBoxExForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = vk_F1 then HelpBtn.Click;
  if Key <> vk_Esc then Exit;
  if CancelBtn.Visible then ModalResult := mrCancel
  else ModalResult := mrNo;
end;

procedure TBoxExForm.FormCreate(Sender: TObject);
begin
  by := YesBtn.Left;
  bn := NoBtn.Left;
  bc := CancelBtn.Left;
  bh := HelpBtn.Left;
end;

procedure TBoxExForm.FormHide(Sender: TObject);
begin
  Position := poScreenCenter;
end;

initialization

  BoxExForm := TBoxExForm.Create(nil);

end.
